using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing.Drawing2D;
using System.Windows.Forms.Design;
using System.ComponentModel.Design;
using System.Windows.Forms;
using System.Drawing.Design;

namespace Lib
{   
    [System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand, Name = "FullTrust")]
    internal class LinearGradentUIEditor : System.Drawing.Design.UITypeEditor    
    {
        public LinearGradentUIEditor() {
        }

        public override object EditValue(System.ComponentModel.ITypeDescriptorContext context, System.IServiceProvider provider, object value) {
            if (value.GetType() != typeof(MyWraper))
                return value;

            IWindowsFormsEditorService editorService = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));
            if (editorService != null) {
                IDesignerHost designerHost = (IDesignerHost)provider.GetService(typeof(IDesignerHost));
                if (designerHost != null && context != null) {
                    using (LinearGradentEditorForm form = new LinearGradentEditorForm(((MyWraper)value).Brush)) {
                        if (editorService.ShowDialog(form) == DialogResult.OK) {
                            context.OnComponentChanging();
                            context.OnComponentChanged();
                        }
                    }
                }
            }

            return value;
        }

        public override System.Drawing.Design.UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context) {
            return UITypeEditorEditStyle.Modal;
        }

        public override bool GetPaintValueSupported(System.ComponentModel.ITypeDescriptorContext context) {
            return false;
        }
    }
}
