using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel.Design.Serialization;
using System.CodeDom;
using System.Drawing.Drawing2D;
using System.Drawing;


namespace Lib
{
    internal class LinearGradientDesignerSerializer : CodeDomSerializer
    {        
        public override object Serialize(IDesignerSerializationManager manager, object value) {
            CodeDomSerializer serializer = manager.GetSerializer(value.GetType().BaseType, typeof(CodeDomSerializer)) as CodeDomSerializer;
            object codeObject = serializer.Serialize(manager, value);
            CodeStatementCollection codeStatements = codeObject as CodeStatementCollection;
            MyWraper wraper = value as MyWraper;

            if ((codeStatements != null) && (wraper != null)) {
                CodeExpression controlExpression = this.GetExpression(manager, value);

                // deklarise se niz Color[] linearColors
                CodeArrayCreateExpression refLinearColorsA = new CodeArrayCreateExpression("System.Drawing.Color", 2);
                CodeVariableDeclarationStatement refLinearColorsStatement = new CodeVariableDeclarationStatement("System.Drawing.Color[]", "linearColors", refLinearColorsA);
                codeStatements.Add(refLinearColorsStatement);

                // zatim se dodaje prva boja u linearColors[0]
                CodeVariableReferenceExpression c1 = new CodeVariableReferenceExpression("System.Drawing.Color");
                CodeMethodInvokeExpression c1Method = new CodeMethodInvokeExpression(c1, "FromArgb",         
                        new CodePrimitiveExpression(wraper.Brush.LinearColors[0].A),
                        new CodePrimitiveExpression(wraper.Brush.LinearColors[0].R),
                        new CodePrimitiveExpression(wraper.Brush.LinearColors[0].G),
                        new CodePrimitiveExpression(wraper.Brush.LinearColors[0].B));


                // radi assignment linearColors[0] = System.Drawing.Color.FromArgb
                CodeArrayIndexerExpression refLinearColorsI1 = new CodeArrayIndexerExpression(new CodeVariableReferenceExpression("linearColors"), new CodePrimitiveExpression(0));
                CodeAssignStatement as1 = new CodeAssignStatement(refLinearColorsI1, c1Method);
                codeStatements.Add(as1);


                // pa druga linearColors[1]
                CodeVariableReferenceExpression c2 = new CodeVariableReferenceExpression("System.Drawing.Color");
                CodeMethodInvokeExpression c2Method = new CodeMethodInvokeExpression(c2, "FromArgb",
                        new CodePrimitiveExpression(wraper.Brush.LinearColors[1].A),
                        new CodePrimitiveExpression(wraper.Brush.LinearColors[1].R),
                        new CodePrimitiveExpression(wraper.Brush.LinearColors[1].G),
                        new CodePrimitiveExpression(wraper.Brush.LinearColors[1].B));


                // radi assignment linearColors[1] = System.Drawing.Color.FromArgb
                CodeArrayIndexerExpression refLinearColorsI2 = new CodeArrayIndexerExpression(new CodeVariableReferenceExpression("linearColors"), new CodePrimitiveExpression(1));
                CodeAssignStatement as2 = new CodeAssignStatement(refLinearColorsI2, c2Method);
                codeStatements.Add(as2);

                // na kraju dodeljuje linearColors MyButton-u  this.myButton1.GradientBrush.Brush.LinearColors = linearColors;
                // ovo je skracena verzija u sustini trebalo bi postepeno ici sa vracanjem propertija 
                // znaci ovo wraper.Parent.Name + ".GradientBrush.Brush.LinearColors bi trebalo postepeno a i ne mora :)
                CodeVariableReferenceExpression refLinearColors = new CodeVariableReferenceExpression("linearColors");
                CodePropertyReferenceExpression refMyButton = new CodePropertyReferenceExpression(new CodeThisReferenceExpression(), wraper.Parent.Name + ".GradientBrush.Brush.LinearColors");

                CodeAssignStatement as3 = new CodeAssignStatement(refMyButton, refLinearColors);
                codeStatements.Add(as3);                
            }

            return codeObject;
        }
    }
}
